<s:schema xmlns:xs="http://www.w3.org/2001/XMLSchema"
          xmlns:xlink="http://www.w3.org/1999/xlink"
          xmlns:db="http://docbook.org/ns/docbook"
          xmlns:s="http://purl.oclc.org/dsdl/schematron">
   <s:ns prefix="db" uri="http://docbook.org/ns/docbook"/>
   <s:ns prefix="xlink" uri="http://www.w3.org/1999/xlink"/>
   <s:pattern xmlns:dcterms="http://purl.org/dc/terms/"
              name="Only one kind of linking per element"><!-- "and" in the context is intentional --><s:rule context="db:*[@linkend and @xlink:*]">
         <s:assert test="not(@linkend) or not(@xlink:*)">@linkend cannot be combined with XLink.</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on orderedlist">
      <s:rule context="db:orderedlist">
         <s:assert test="not(@startingnumber and @continuation)">List numeration can only be specified with @startingnumber or @continuation, not both</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on simplelist">
      <s:rule context="db:simplelist">
         <s:assert test="not(@columns) or not(@type) or (@type != 'inline')">Inline simple lists cannot have @columns</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on example">
      <s:rule context="db:example">
         <s:assert test="not(@width and @pgwide)">Only one of @width or @pgwide may be specified.</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on informalexample">
      <s:rule context="db:informalexample">
         <s:assert test="not(@width and @pgwide)">Only one of @width or @pgwide may be specified.</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on literallayout">
      <s:rule context="db:literallayout">
         <s:assert test="not(@xml:space) or @xml:space='preserve'">In literallayout, @xml:space must be 'preserve'</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on videodata">
      <s:rule context="db:videodata">
         <s:assert test="@fileref or @entityref and not(@fileref and @entityref)">Only one of @fileref or @entityref may be specified</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on audiodata">
      <s:rule context="db:audiodata">
         <s:assert test="@fileref or @entityref and not(@fileref and @entityref)">Only one of @fileref or @entityref may be specified</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on imagedata">
      <s:rule context="db:imagedata">
         <s:assert test="@fileref or @entityref and not(@fileref and @entityref)">Only one of @fileref or @entityref may be specified</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on textdata">
      <s:rule context="db:textdata">
         <s:assert test="@fileref or @entityref and not(@fileref and @entityref)">Only one of @fileref or @entityref may be specified</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on areaspec">
      <s:rule context="db:areaspec">
         <s:assert test="(not(@units eq 'other') and not(@otherunits))                        or (@units='other' and @otherunits)">The @units/@otherunits attributes must be consistent</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on area">
      <s:rule context="db:area">
         <s:assert test="(not(@units eq 'other') and not(@otherunits))                        or (@units='other' and @otherunits)">The @units/@otherunits attributes must be consistent</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on area">
      <s:rule context="db:area">
         <s:assert test="not(@linkends) or not(@xlink:href)">Only one of @linkends/@xlink:href may be specified</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on areaset">
      <s:rule context="db:areaset">
         <s:assert test="(not(@units eq 'other') and not(@otherunits))                              or (@units='other' and @otherunits)">The @units/@otherunits attributes must be consistent</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on areaset">
      <s:rule context="db:areaset">
         <s:assert test="(not(@units eq 'other') and not(@otherunits))                        or (@units='other' and @otherunits)">The @units/@otherunits attributes must be consistent</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on areaset">
      <s:rule context="db:areaset">
         <s:assert test="not(@linkends) or not(@xlink:href)">Only one of @linkends/@xlink:href may be specified</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on address">
      <s:rule context="db:address">
         <s:assert test="not(@xml:space) or @xml:space='preserve'">In address, @xml:space must be 'preserve'</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on orgname">
      <s:rule context="db:orgname">
         <s:assert test="(not(@class eq 'other') and not(@otherclass))                            or (@class='other' and @otherclass)">The @class/@otherclass attributes must be consistent</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on personname">
      <s:rule context="db:personname">
         <s:assert test="normalize-space(string-join(text(),'')) = ''                        or (not(db:honorific) and not(db:firstname) and not(db:surname)                            and not(db:lineage) and not(db:othername))">A personname must be text or honorific/firstname/surname/lineage/othername, not both</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on biblioid">
      <s:rule context="db:biblioid">
         <s:assert test="(not(@class eq 'other') and not(@otherclass))                            or (@class='other' and @otherclass)">The @class/@otherclass attributes must be consistent</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on citebiblioid">
      <s:rule context="db:citebiblioid">
         <s:assert test="(not(@class eq 'other') and not(@otherclass))                            or (@class='other' and @otherclass)">The @class/@otherclass attributes must be consistent</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on bibliosource">
      <s:rule context="db:bibliosource">
         <s:assert test="(not(@class eq 'other') and not(@otherclass))                            or (@class='other' and @otherclass)">The @class/@otherclass attributes must be consistent</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on bibliorelation">
      <s:rule context="db:bibliorelation">
         <s:assert test="(not(@class eq 'other') and not(@otherclass))                            or (@class='other' and @otherclass)">The @class/@otherclass attributes must be consistent</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on bibliorelation">
      <s:rule context="db:bibliorelation">
         <s:assert test="(not(@type eq 'other') and not(@othertype))                            or (@type='other' and @othertype)">The @type/@othertype attributes must be consistent</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on bibliocoverage">
      <s:rule context="db:bibliocoverage">
         <s:assert test="(not(@spatial eq 'other') and not(@otherspatial))                             or (@spatial='other' and @otherspatial)">The @spatial/@otherspatial attributes must be consistent</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on bibliocoverage">
      <s:rule context="db:bibliocoverage">
         <s:assert test="(not(@temporal eq 'other') and not(@othertemporal))                             or (@temporal='other' and @othertemporal)">The @temporal/@othertemporal attributes must be consistent</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on othercredit">
      <s:rule context="db:othercredit">
         <s:assert test="(not(@class eq 'other') and not(@otherclass))                        or (@class='other' and @otherclass)">The @class/@otherclass attributes must be consistent</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on indexterm">
      <s:rule context="db:indexterm">
         <s:assert test="@class='endofrange' or not(@startref)">Only end-of-range indexterms may have @startref</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on indexterm">
      <s:rule context="db:indexterm">
         <s:assert test="not(@class='endofrange')                        or (@startref and not(@significance) and not(@zone) and not(@pagenum)                            and not(@scope) and not(@type))">End-of-range indexterms must have @startref and must not have @significance, @zone, @pagenum, @scope, or @type</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on indexterm">
      <s:rule context="db:indexterm">
         <s:assert test="not(@class='endofrange') or not(*)">End-of-range indexterms must be empty</s:assert>
      </s:rule>
   </s:pattern>
   <s:pattern name="Assertion on speaker">
      <s:rule context="db:speaker">
         <s:assert test="not(db:person) or (normalize-space(text()) = '')">Content must be text or person, not both</s:assert>
      </s:rule>
   </s:pattern>
</s:schema>